## ngs-sdk 2.11.2

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# default response to "make"
default: std

std: subdirs

# the sub-directories
SUBDIRS =    \
	ngs-sdk \
	ngs-java \
	ngs-python \

SUBDIRS_CLN = \
	$(addsuffix _cln,$(SUBDIRS))

SUBDIRS_INST = \
	$(addsuffix _inst,$(SUBDIRS))

SUBDIRS_TST = \
	$(addsuffix _test,$(SUBDIRS))

subdirs: $(SUBDIRS)

clean: $(SUBDIRS_CLN)

test: $(SUBDIRS_TST)

install: $(SUBDIRS_INST)

$(SUBDIRS):
	@ $(MAKE) -C $@

$(SUBDIRS_CLN):
	@ $(MAKE) -C $(subst _cln,,$@) clean

$(SUBDIRS_INST):
	@ $(MAKE) -s --no-print-directory -C $(subst _inst,,$@) install

$(SUBDIRS_TST):
	@ $(MAKE) -C $(subst _test,,$@) test

.PHONY: $(SUBDIRS) $(SUBDIRS_CLN) $(SUBDIRS_INST)

=== ngs-python/examples/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

std:

clean:

.PHONY: default std $(TARGETS)

PYTHON ?= python3

PYTHON_VERS = $(shell $(PYTHON) -V 2>&1)

# there is a separate set of sources for 2.5 and 2.6
ifeq (Python 2.6,$(shell expr "$(PYTHON_VERS)" : "\(Python 2.6\)"))
    PYTHON_VERS=26
else
    ifeq (Python 2.5,$(shell expr "$(PYTHON_VERS)" : "\(Python 2.5\)"))
        PYTHON_VERS=26
    else
        PYTHON_VERS=
    endif
endif

NGS_EXAMPLES = \
	FragTest \
	AlignTest \
	AlignSliceTest \
	PileupTest \
	RefTest \

# ===========================================================================
#
# example runs
#
# NOTE: Expect libngs-sdk.so and libncbi-vdb.so somewhere inside $LD_LIBRARY_PATH

run_frag:
	$(PYTHON) FragTest$(PYTHON_VERS).py ERR225922 10000 2 $(REDIRECT)

run_align:
	$(PYTHON) AlignTest$(PYTHON_VERS).py ERR225922 10000 2 $(REDIRECT)

run_align_slice:
	$(PYTHON) AlignSliceTest$(PYTHON_VERS).py SRR1121656 1 1 9999 $(REDIRECT)

run_pileup:
	$(PYTHON) PileupTest$(PYTHON_VERS).py SRR1121656 1 9999 10003 $(REDIRECT)

run_ref:
	$(PYTHON) RefTest$(PYTHON_VERS).py SRR1121656 $(REDIRECT)

ALL_TESTS = run_frag run_align run_align_slice run_pileup run_ref

run_all: $(ALL_TESTS)

.PHONY: run_align run_align_slice run_frag

# ===========================================================================
#
# expected results for auto-testing
#
expected.txt update_expected:
	@if [ "$(PYTHON_VERS)" = "26" ] ; then \
		echo Python 2.6 is not supported ; \
	else \
		rm -f expected.txt; LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) $(MAKE) run_all REDIRECT=">>expected.txt" ; \
	fi

run_and_diff: expected.txt
	@if [ "$(PYTHON_VERS)" = "26" ] ; then \
		echo Python 2.6 is not supported ; \
	else \
		rm -f actual.txt; LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) $(MAKE) run_all REDIRECT=">>actual.txt" ; \
		diff expected.txt actual.txt && rm actual.txt && echo NGS Python examples work as expected ; \
	fi


.PHONY: update_expected run_and_diff

=== ngs-sdk/examples/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: std

ifeq (Darwin,$(shell uname -s))
    MFLAGS += -mmacosx-version-min=10.10
endif

CC = gcc $(MFLAGS) $(CFLAGS)
CXX = g++ $(MFLAGS) $(CPPFLAGS)

# ensure definition of paths, namely
# NCBI_VDB_LIBDIR and NGS_LIBDIR
include $(CURDIR)/Makefile.config
#$(warning CPPFLAGS=$(CPPFLAGS))

TARGETS =               \
	AlignSliceTest      \
	AlignTest           \
	DumpReferenceFASTA  \
	FastqTableDump      \
	FragTest            \
	PileupTest          \
	RefTest             \

# This rule triggers detection of the libraries and headers
# in addition to building the examples
std: $(TARGETS)

$(TARGETS): $(NCBI_VDB_LIBDIR)/libncbi-vdb-static.a ncbi-headers $(NGS_LIBDIR)/libngs-c++.a ngs-headers

clean:
	echo $(LD_LIBRARY_PATH)
	rm -f $(TARGETS) *.o
	rm -rf *.dSYM

.PHONY: default std $(TARGETS)

# C++ applications require several static libraries:
#  1. libngs-c++.a and libngs-adapt-c++.a which contain the NGS "front-end" interfaces.
#  2. an NGS "back-end" engine such as libncbi-ngs-c++.a
#     which in turn relies upon ncbi-vdb to access the SRA (libncbi-ngs.a, libncbi-vdb-static.a)
#
TEST_LIBS =              \
	-L$(NCBI_VDB_LIBDIR) \
	-L$(NGS_LIBDIR)      \
	-lncbi-ngs-c++       \
	-lncbi-ngs           \
	-lncbi-vdb-static    \
	-lngs-c++            \
	-lngs-adapt-c++      \
	-lpthread            \
	-ldl                 \
	-lm                  \


# AlignSliceTest
#  slice a ReadCollection and output alignments
ALIGNSLICE_TEST_SRC = \
	AlignSliceTest.cpp

AlignSliceTest: $(ALIGNSLICE_TEST_SRC)
	$(CXX) -g -o $@ $(ALIGNSLICE_TEST_SRC) $(TEST_LIBS)


# AlignTest #################
#  access alignments
ALIGN_TEST_SRC = \
	AlignTest.cpp

AlignTest: $(ALIGN_TEST_SRC)
	$(CXX) -g -o $@ $(ALIGN_TEST_SRC) $(TEST_LIBS)


# DumpReferenceFASTA
DUMP_SRC = \
	DumpReferenceFASTA.cpp
DumpReferenceFASTA: $(DUMP_SRC)
	$(CXX) -g -o $@ $(DUMP_SRC) $(TEST_LIBS)


# FastqTableDump
#  produce fastq-like table
FASTQ_TABLE_DUMP_OBJ = \
	FastqTableDump.cpp

FastqTableDump: $(FASTQ_TABLE_DUMP_OBJ)
	$(CXX) -g -o $@ $(FASTQ_TABLE_DUMP_OBJ) $(TEST_LIBS)


# FragTest
#  access read fragments
FRAG_TEST_SRC = \
	FragTest.cpp

FragTest: $(FRAG_TEST_SRC)
	$(CXX) -g -o $@ $(FRAG_TEST_SRC) $(TEST_LIBS)


# PileupTest
#  slice a ReadCollection and produce pileups
PILEUP_TEST_OBJ = \
	PileupTest.cpp

PileupTest: $(PILEUP_TEST_OBJ)
	$(CXX) -g -o $@ $(PILEUP_TEST_OBJ) $(TEST_LIBS)


# RefTest ###################
REF_TEST_SRC = \
	RefTest.cpp

RefTest: $(REF_TEST_SRC)
	$(CXX) -g -o $@ $(REF_TEST_SRC) $(TEST_LIBS)

# ===========================================================================
#
# installation
#
install:
	@ cp *.cpp Makefile Makefile.config $(INST_TARGET)

# ===========================================================================
#
# example runs

run_frag:  FragTest
	./$^ ERR225922 10000 2 $(REDIRECT)

run_align: AlignTest
	./$^ ERR225922 10000 2 $(REDIRECT)

run_dump: DumpReferenceFASTA
	./$^ SRR520124 1 $(REDIRECT)

run_align_slice: AlignSliceTest
	./$^ SRR1121656 1 1 9999 $(REDIRECT)

run_pileup: PileupTest
	./$^ SRR1121656 1 9999 10003 $(REDIRECT)

run_ref: RefTest
	./$^ SRR1121656 $(REDIRECT)

ALL_TESTS = run_frag run_align run_align_slice run_pileup run_ref run_dump

run_all: $(ALL_TESTS)

.PHONY: $(ALL_TESTS)

# ===========================================================================
#
# expected results for auto-testing
#
expected.txt update_expected:
	rm -f expected.txt
	export LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) ; $(MAKE) run_all REDIRECT=">>expected.txt"

run_and_diff: expected.txt
	@ rm -f actual.txt
	@ echo http_proxy=$(http_proxy)
	@ export LD_LIBRARY_PATH=$(LD_LIBRARY_PATH) ; $(MAKE) run_all REDIRECT=">>actual.txt"
	@ diff expected.txt actual.txt && rm actual.txt && echo "NGS C++ examples work as expected"

.PHONY: update_expected run_and_diff install

=== ngs-sdk/test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: subdirs

TOP ?= $(abspath ..)
export TOP

SUBDIRS =  \
	test_engine    \
	ngs-test

SUBDIRS_CLN = \
	$(addsuffix _cln,$(SUBDIRS))

SUBDIRS_TST = \
	$(addsuffix _tst,$(SUBDIRS))

subdirs: $(SUBDIRS)

clean: $(SUBDIRS_CLN)

test runtests: $(SUBDIRS_TST)

$(SUBDIRS):
	@ $(MAKE) -C $@

$(SUBDIRS_CLN):
	@ $(MAKE) -s -C $(subst _cln,,$@) clean

$(SUBDIRS_TST):
	@ $(MAKE) -C $(subst _tst,,$@) runtests

.PHONY: default subdirs $(SUBDIRS) $(SUBDIRS_CLN) $(SUBDIRS_TST)

=== debian/changelog ===
ngs-sdk (2.11.2-3) unstable; urgency=medium

  * Team upload

  [ Lance Lin ]
  * Added autopkg test

  [ Andreas Tille ]
  * Update copyright years

 -- Lance Lin <lqi254@protonmail.com>  Fri, 18 Feb 2022 20:44:26 +0100

ngs-sdk (2.11.2-2) unstable; urgency=medium

  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Thu, 03 Feb 2022 14:11:43 +0100

ngs-sdk (2.11.2-1) unstable; urgency=medium

  * d/watch: Use filemangle to make sure the archive will not mixed up
    with other ncbi code with same version
  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 14 Oct 2021 10:03:41 +0200

=== debian/control ===
Source: ngs-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Olivier Sallou <osallou@debian.org>,
           Vincent Danjean <vdanjean@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               markdown <!nodoc>,
               python3-all,
               python3-distutils,
               dh-python,
               javahelper,
               maven-repo-helper,
               default-jdk
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/ngs-sdk
Vcs-Git: https://salsa.debian.org/med-team/ngs-sdk.git
Homepage: https://github.com/ncbi/ngs
Rules-Requires-Root: no

Package: libngs-sdk2
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libngs-sdk-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libngs-sdk2 (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the development package.

Package: libngs-java
Multi-Arch: same
Architecture: any
Section: java
Depends: ${misc:Depends},
         ${java:Depends},
         libngs-sdk-dev (= ${binary:Version})
Recommends: ${java:Recommends}
Description: Next Generation Sequencing language Bindings (Java bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java bindings.

Package: python3-ngs
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${misc:Depends},
         libngs-sdk-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (Python3 bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(MULTIARCH)/$(DEB_SOURCE)/$(OS)/gcc/*

build3vers := $(shell py3versions -sv)

%:
	dh $@ --with python3,javahelper,jh_maven_repo_helper

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
	#    dh_auto_clean --sourcedirectory=$(DEB_SOURCE) ; \
	dh_auto_clean ; \
	fi
	rm -rf ngs-java/$(MULTIARCH)
	rm -rf ngs-bam/$(MULTIARCH)
	rm -f ngs-bam/Makefile.config
	rm -f ngs-bam/Makefile.config.install.linux.x86_64.prl
	rm -f ngs-bam/Makefile.config.linux.x86_64
	rm -f ngs-bam/reconfigure
	rm -rf ngs-sdk/ngs/unix/generic

	rm -rf $(DEB_SOURCE)/$(MULTIARCH)
	rm -rf ngs-python/build

override_dh_auto_configure:
	mkdir ngs-sdk/ngs/unix/generic && cp debian/atomic32.h ngs-sdk/ngs/unix/generic/
	# # that's no standard configure script lacking support of default options \
	./configure --build=$(MULTIARCH) --prefix=/usr -- --source=1.7

override_dh_auto_build:
	#dh_auto_build --sourcedirectory=$(DEB_SOURCE)
	echo "DEBPKGNAME: $DEBPKGNAME"
	dh_auto_build --sourcedirectory=$(DEB_SOURCE)
	# Remove ngs-bam generation, expects ngs-sdk and cannot find a way
	# to specify it
	#cd ngs-bam && LD_LIBRARY_PATH=../$(SODIR)/rel/lib ./configure --build=$(MULTIARCH) --prefix=/usr --with-ngs-sdk-prefix=../ngs-sdk
	#dh_auto_build --sourcedirectory=ngs-bam
	dh_auto_build --sourcedirectory=ngs-java -- JAVAC="javac -source 1.7 -target 1.7"
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	markdown README.md > README.html
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make -C $(DEB_SOURCE)/test
	# Tests of Java binding disabled because need external lib ncbi-vdb,
	# not available in Debian at this time
	#CLASSPATH=../$(MULTIARCH)/ngs-java/jar/ngs-java.jar LD_LIBRARY_PATH=$(SODIR)/rel/lib:$(LD_LIBRARY_PATH) make -C ngs-java/examples
	#CLASSPATH=../$(MULTIARCH)/ngs-java/jar/ngs-java.jar LD_LIBRARY_PATH=../../$(SODIR)/rel/lib:$(LD_LIBRARY_PATH) make -C ngs-java/examples run_all
endif

override_dh_auto_install:
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "$(SODIR)/rel/lib/*.a*" usr/lib/$(MULTIARCH) \
		    --movedev "$(SODIR)/rel/ilib/*.a" usr/lib/$(MULTIARCH) \
		    --movedev ngs-sdk/ngs usr/include \
		    $(SODIR)/rel/lib/libngs-sdk.so

override_dh_install:
	dh_install -ppython3-ngs
	set -e && for i in $(build3vers); do \
		cd ngs-python ; \
		python$$i ./setup.py install --install-layout=deb --root ../debian/python3-ngs; \
		cd .. ; \
	done
	find debian -name "*.pyc" -delete
	find debian -type d -name __pycache__ | xargs rm -rf

# require network, not automatically run
# use it when the pom file must be re-downloaded from maven repo
BASE_URL:=https://repo.maven.apache.org/maven2/gov/nih/nlm/ncbi/ngs-java
WGET=wget --no-clobber
get-poms:
	$(RM) debian/ngs-java.pom debian/ngs-java.pom.asc
	# extract upstream version
	$(WGET) -O debian/ngs-java.pom $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom && \
	$(WGET) -O debian/ngs-java.pom.asc $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom.asc
	gpg --trust-model=always --status-fd 1 --no-default-keyring --keyring debian/sra-tools.gpg --verify debian/ngs-java.pom.asc

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/ncbi/ngs/tags .*/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
